"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createPlugin;

var _slateKitHighlightTextRenderer = require("@vericus/slate-kit-highlight-text-renderer");

var _slateKitHighlightTextRenderer2 = _interopRequireDefault(_slateKitHighlightTextRenderer);

var _options = require("./options");

var _options2 = _interopRequireDefault(_options);

var _changes = require("./changes");

var _changes2 = _interopRequireDefault(_changes);

var _utils = require("./utils");

var _utils2 = _interopRequireDefault(_utils);

var _schemas = require("./schemas");

var _schemas2 = _interopRequireDefault(_schemas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPlugin(pluginOptions) {
  var options = _options2.default.create(pluginOptions);
  var changes = (0, _changes2.default)(options);
  var schemas = (0, _schemas2.default)();
  var utils = (0, _utils2.default)(options);
  var plugin = (0, _extends3.default)({
    options: options,
    changes: changes,
    utils: utils
  }, schemas);
  if (!options.externalRenderer) {
    var _Renderer = (0, _slateKitHighlightTextRenderer2.default)(options),
        renderMark = _Renderer.renderMark;

    plugin.renderMark = renderMark;
  }
  return plugin;
}